<template>
  <v-layout
    class="writing-activity"
    fill-height
    align-start
    v-touch="{
      left: () => next(),
      right: () => back(),
      }"
  >
    <writing-wrapper
      :activity="activity"
      :text="text"
      :loading="loading"
      :feedback="feedback"
      :activeTab="activeTab"
      :slideName="slideName"
      :progress="progress"
      :stationName="stationName"
      @update:text="updateText"
      @setTab="setTab"
      @help="help"
      @exit="exit"
      @check="check"
    />
    <feedback-msg
      :feedback="feedback"
      @reaction="reaction"
      @retry="retry"
      @feedbackContinue="feedbackContinue"
    />
  </v-layout>
</template>

<script>
import WritingWrapper from './components/WritingWrapper';
import FeedbackMsg from '../Globals/Feedback/Index';

export default {
  props: {
    activity: {
      type: Object,
    },
    feedback: {
      type: Object,
    },
    progress: {
      type: Object,
    },
    loading: {
      type: Boolean,
      default: false,
    },
    activeTab: {
      type: Number,
      default: () => 0,
    },
    text: {
      type: String,
      default: () => '',
    },
    stationName: {
      type: String,
      default: () => '',
    },
  },
  components: {
    WritingWrapper,
    FeedbackMsg,
  },
  data() {
    return {
      slideName: 'slide-left',
    };
  },
  methods: {
    exit() {
      this.$emit('exit');
    },
    setTab(tab) {
      this.$emit('update:activeTab', tab);
    },
    updateText(text) {
      this.$emit('update:text', text);
    },
    next() {
      this.slideName = 'slide-left';
      const active = Number(this.activeTab);
      const activeTab = active < 2 ? active + 1 : 2;
      this.setTab(activeTab);
    },
    back() {
      this.slideName = 'slide-right';
      const active = Number(this.activeTab);
      const activeTab = active > 1 ? active - 1 : 0;
      this.setTab(activeTab);
    },
    help() {
      this.$emit('help');
    },
    retry() {
      this.$emit('retry');
    },
    check() {
      this.$emit('check');
    },

    feedbackContinue() {
      this.$emit('feedbackContinue');
    },
    reaction(data) {
      this.$emit('reaction', data);
    },
  },
};
</script>

<style lang="sass" scoped>
  @import ~@/styles/defaults/mobileFirst
  .writing-activity
    width: 100%
    display: flex
    flex-wrap: wrap
    transition: 0.4s ease all
    +media-min-lg()
      flex-direction: unset
      height: auto
</style>
